; Program GSM alarm pro motocykly, M35i                  
;*                                                  Martin Benicek   2009 *
;**************************************************************************

 list	p=PIC16F628A, R=DEC
#include	<P16F628A.inc>

#define ENTER 0x0D
;port B
#define CIDLO1 5
#define CIDLO2 4
#define CIDLO3 3
#define CIDLO4 6

;port A
#define VYPINAC 1
#define LED 0
#define CIDLONAP 4

;pro STAVHOVOR
#define NARUSENI 0
#define VOLAT1 1
#define VOLANI 2
#define VOLAT2 3
#define HOVORTYP 4
#define HOVOR 5
#define SMSPRODL 6
#define SMSPOSLI 7

;pro FLAGS1
#define SPOJENI_OK 0
#define NO_RECEIVE 1
#define TMPOK 2
#define STAVVYPINACE 3
#define ODCHODPRODL 4
#define LEDSVIT 5
#define STAVNAPETI 6

;pro FLAGS2
#define ODCHODPRODL2 0
#define NO_OK 1
#define CISLO_OK 2

;pro NASTAVENI
#define VOLEJXXX 0
#define VOLEJVZDY 1

#define KTIMECIDEL .1	; doba kontroly cidel, v nasobcich 100ms
#define KTIMESMS .5	; doba kontroly SMS, v nasobcich 1s
#define KNARUSENI .5	; doba nez se po naruseni vrati do pohotovostniho stavu v 1 min
#define KVOLAT1 .20	; prodleva pred prvnim volanim po naruseni v nasobcich 1s
#define KVOLAT2 .60	; prodleva mezi dvema volanimiv nasobbcich 1s
#define KVOLAT2XXX .5	; prodleva mezi dvema volanimiv nasobbcich 1s pro volani na vice tel cisel
#define KHOVORTYP .30	; doba mezi dvema kontrolama stavu volani v nasobcich 100ms
#define KVOLANI .40	; doba volani v nasobcich 1s
#define KSMSPRODL .20	; prodleva pred prvnim poslanim SMS v nasobcich 1s
#define KODCHODPRODL .20 ; doba prodlevy pri odchodu v nasobcich 1s
#define KBLIKANIYES .3	; doba svitu LED v pohot. stavu v nasobcich 100ms
#define KBLIKANINO .12	; doba zhasnuti LED v pohot. stavu v nasobcich 100ms
#define KKONTRPRODL b'01101000'	; implicitni nastaveni cidel, ktera nemaji pri odchodu prodlevu(prislusny bit je 1)
#define KKONTRVZOR b'01111000'	;implicitni nastaveni cidel, ktera se maji kontrolovat
#define KSTAVOK b'01111000'	;implicitni nastaveni stavu OK pro cidla
#define KKONTRPOSSMS1 b'01111110'	;implicitni nastaveni poslani SMS pri naruseni cidel
#define KKONTRPOSSMS2 b'00000000'	;implicitni nastaveni poslani SMS pri naruseni cidel
#define KKONTRPOSSMS3 b'00000000'	;implicitni nastaveni poslani SMS pri naruseni cidel
#define KKONTRPRIPRODL b'00000000'	; implicitni nastaveni cidel, ktera maji pri prichodu prodlevu(prislusny bit je 1)
#define KPOCETHOVOR .1	; implicitni nastaveni poctu hovoru
#define KNASTAVENI b'00000000'	; nastaveni zda se bude volat an vice tel cisel



RAM		equ	20h	; prvni adresa pameti RAM pro PIC16F628A
TMP		equ	RAM+01	; temp preruseni
CAS0	equ	RAM+02	; promenna casovacich rutin 
CAS1	equ	RAM+03	; promenna casovacich rutin 
CAS2	equ	RAM+04	; promenna casovacich rutin 
FLAGS1	equ	RAM+05	; promenna pro kontrolu komunikace a stavu programu 
TMP0	equ	RAM+06	; temp pomocny 

TIMECIDEL	equ RAM+07	; promenna cyklu kontroly cidel, v nasobcich 100ms
TIME100MS	equ RAM+08	; promenna pro 100ms
TIME1S	equ RAM+09	; promenna pro 1s
TIMESMS	equ RAM+10	; promenna cyklu kontroly nove SMS, v nasobcich 1s
TIME1M	equ RAM+11	; promenna pro 1min    

TLFA1 	equ RAM+12
TLFA2 	equ RAM+13
TLFA3 	equ RAM+14
TLFA4 	equ RAM+15
TLFA5 	equ RAM+16
TLFA6 	equ RAM+17
TLFA7 	equ RAM+18
TLFA8 	equ RAM+19
TLFA9 	equ RAM+20

TLFB1 	equ RAM+21
TLFB2 	equ RAM+22
TLFB3 	equ RAM+23
TLFB4 	equ RAM+24
TLFB5 	equ RAM+25
TLFB6 	equ RAM+26
TLFB7 	equ RAM+27
TLFB8 	equ RAM+28
TLFB9 	equ RAM+29

TLFC1 	equ RAM+30
TLFC2 	equ RAM+31
TLFC3 	equ RAM+32
TLFC4 	equ RAM+33
TLFC5 	equ RAM+34
TLFC6 	equ RAM+35
TLFC7 	equ RAM+36
TLFC8 	equ RAM+37
TLFC9 	equ RAM+38

TLF1TMP 	equ RAM+39
TLF2TMP 	equ RAM+40
TLF3TMP 	equ RAM+41
TLF4TMP 	equ RAM+42
TLF5TMP 	equ RAM+43
TLF6TMP 	equ RAM+44
TLF7TMP 	equ RAM+45
TLF8TMP 	equ RAM+46
TLF9TMP 	equ RAM+47

KONTRPOSSMS1	equ RAM+48
KONTRPOSSMS2	equ RAM+49
KONTRPOSSMS3	equ RAM+50

STAVSMS1	equ RAM+51	;promenna pro poslani SMS na prvni tel cislo
STAVSMS2	equ RAM+52
STAVSMS3	equ RAM+53

NASTAVENI	equ RAM+54	;promenna pro nastaveni (vice tel cisel ap)
POCETHOVORM	equ RAM+55	;promenna pro poctu hovoru
POCETHOVOR	equ RAM+56	;promenna pro pocitani poctu hovoru

STAVOK  equ RAM+57
KONTR	equ RAM+58
STAVHOVOR	equ RAM+59
STAVSMS	equ RAM+60
CNARUSENI equ RAM+61
CVOLAT1 equ RAM+62
CVOLANI equ RAM+63
CHOVORTYP equ RAM+64
CSMSPRODL equ RAM+65
CODCHODPRODL equ RAM+66
CBLIKANI equ RAM+67

FLAGS2 equ RAM+68	;promenna pro stavy programu, pokracovani FLAGS1

KONTRPRODL	equ RAM+69
KONTRVZOR	equ RAM+70
KONTRPRIPRODL equ RAM+71
TMPKONTR equ RAM+72



;************************     Nastaveni konfiguracniho bytu   *************************

	org	0x2007		; adresa nastaveni pojistek pro PIC16F628
	dw  _DATA_CP_OFF & _CP_OFF & _BOREN_OFF & _PWRTE_OFF & _WDT_OFF & _LVP_OFF & _MCLRE_ON &  _XT_OSC

;************************     Reset procesoru     *************************

	org 0x0000
	goto INIT	
	
;************************     Obsluha preruseni pri testu komunikace s mobilem    *************************

	org 0x0004
;int od seriove linky pouze pro test pripojeni mobilu	
	bcf		STATUS,RP0		;prijme znak z mobilu
	btfss	RCSTA,OERR
	goto	$+3
	bcf RCSTA,CREN
	bsf RCSTA,CREN
	movf RCREG,W
	movwf TMP				;uloz znak do tempu
	bcf STATUS,Z
	movlw 'O'			;testuj znak OK - t.zn. pripojeni v poradku
	subwf TMP,W
	btfss STATUS,Z		;shoda = ven
	retfie
	bsf	FLAGS1,SPOJENI_OK
	retfie 

;************************     Podprogramy     *************************

;---------------casovaci rutina-----150 msec.--------------------------------
CEKAME	

        movlw 0x0E5  ;229 DEC
        movwf CAS1
        movlw 0x0D9  ;217 DEC
        movwf CAS0
        decfsz CAS0,F
        goto $-1
        decfsz CAS1,F
        goto $-5
		return

;------------------casovaci rutina---------1 sec.------------
CEKAME_1	

        movlw 0x15  ;21 DEC
        movwf CAS2
        movlw 0x59  ;89 DEC
        movwf CAS1
        movlw 0x0B1  ;177 DEC
        movwf CAS0
        decfsz CAS0,F
        goto $-1
        decfsz CAS1,F
        goto $-5
        decfsz CAS2,F
        goto $-9
		return

RECEIVE 

        movlw 0xFF  ;255 DEC=cca 200ms
        movwf CAS1
		bcf		STATUS,RP0
		btfss	RCSTA,OERR
		goto	$+3
		bcf RCSTA,CREN
		bsf RCSTA,CREN
        movlw 0xFF  ;255 DEC
        movwf CAS0
		btfsc PIR1,RCIF	;ceka dokud neprijme znak
		goto JETU
        decfsz CAS0,F	; cyklus, pokud znak neprijde do 200ms, ukonci se RECEIVE, nastavi se FLAGS1, NO_RECEIVE 
        goto $-3
        decfsz CAS1,F
        goto $-7
		bsf	FLAGS1,NO_RECEIVE	; nastaveni chyboveho bitu
		goto NENITU
JETU	movf RCREG,W
NENITU	return

; ------------ vyslani 1 znaku na mobil z registru W -------------------------------------------------
SEND
		bcf STATUS,RP0		; RAM PAGE 0 ***

		btfss PIR1,TXIF	;kontrola, zda byl predchozi znak vyslan  ***
		goto $-1	; *****

		movwf TXREG             ; send data in W 
        return

;-------------test komunikace s mobilem-------------------
TEST_PRIPOJENI	;posila cyklicky dotaz do mobilu, dokud nedostane ok nejde ven

		bcf	FLAGS1,SPOJENI_OK
		bsf	STATUS,RP0		;bank 1
		bsf	PIE1,RCIE		;povol INT od seriove linky	
		bsf	INTCON,PEIE
		bsf	INTCON,GIE
		bcf STATUS,RP0
		movlw 'A'
		call SEND
		movlw 'T'
		call SEND
		movlw ENTER
		call SEND
		bsf PORTA,LED			;rozsvit LED
		call CEKAME_1
		bcf PORTA,LED		;zhasni LED
		call CEKAME_1
		bsf PORTA,LED			;rozsvit LED
		call CEKAME_1
		bcf PORTA,LED		;zhasni LED
		call CEKAME_1
		btfss	FLAGS1,SPOJENI_OK		;nastavovan v INT
		goto	TEST_PRIPOJENI
		bsf	STATUS,RP0		;bank 1
		bcf	INTCON,GIE
		bcf	INTCON,PEIE
		bcf	PIE1,RCIE		;zakaz INT od seriove linky	
		bcf STATUS,RP0
		bsf PORTA,LED			;rozsvit LED
		call	CEKAME_1
		call	CEKAME_1
		call	CEKAME_1
		call	CEKAME_1
		call	CEKAME_1

		btfss PIR1,RCIF		; testovani, zda je v bufferu RCREG znak
		goto $+3
		movf RCREG,W		; vyprazdneni bufferu RCREG
		goto $-3
		call CEKAME_1
		call CEKAME_1
		return

;------------ ukonceni hovoru --------------
ZAVESIT
ZAVESS		movlw 'A'
		call SEND
		movlw 'T'
		call SEND
		movlw 'H'
		call SEND
		movlw ENTER
		call SEND

		call KONTROLUJ_CHYBU

		btfsc FLAGS2,NO_OK
		goto ZAVESS
	
		return


;-----------------vytoci telefonni cislo-------------------------
;prikaz
VOLEJ_CISLO	

		movlw	'A'
		call SEND
		movlw 'T'
		call SEND
		movlw 'D'
		call SEND
		movlw '>'
		call SEND

		bcf STATUS,Z
		movf POCETHOVOR,0
		subwf POCETHOVORM,0
		movwf TMP

		movf TMP,0
		bcf STATUS,Z 
		sublw .0
		btfsc STATUS,Z		; Z=1 => shoda
		goto SEZNAM1

		movf TMP,0
		bcf STATUS,Z 
		sublw .1
		btfsc STATUS,Z		; Z=1 => shoda
		goto SEZNAM2

		movf TMP,0
		bcf STATUS,Z 
		sublw .2
		btfsc STATUS,Z		; Z=1 => shoda
		goto SEZNAM3

		movf TMP,0
		bcf STATUS,Z 
		sublw .3
		btfsc STATUS,Z		; Z=1 => shoda
		goto SEZNAM4

		movf TMP,0
		bcf STATUS,Z 
		sublw .4
		btfsc STATUS,Z		; Z=1 => shoda
		goto SEZNAM5

SEZNAM1		movlw '1'
			call SEND
			goto SEZNAMSS
SEZNAM2		movlw '2'
			call SEND
			goto SEZNAMSS
SEZNAM3		movlw '3'
			call SEND
			goto SEZNAMSS
SEZNAM4		movlw '4'
			call SEND
			goto SEZNAMSS
SEZNAM5		movlw '5'
			call SEND
			goto SEZNAMSS

SEZNAMSS

		movlw ';'
		call SEND
		movlw ENTER
		call SEND
		call NAJDI_OK

		return


;-----------------posle telefonni cislo-------------------------
;prikaz
POSLI_CISLO	
		movlw '"'
		call SEND
		movlw '+'
		call SEND
		movlw '4'
		call SEND
		movlw '2'
		call SEND
		movlw '0'
		call SEND
		movf TLF1TMP,0 
		call SEND
		movf TLF2TMP,0 
		call SEND
		movf TLF3TMP,0 
		call SEND
		movf TLF4TMP,0 
		call SEND
		movf TLF5TMP,0 
		call SEND
		movf TLF6TMP,0 
		call SEND
		movf TLF7TMP,0 
		call SEND
		movf TLF8TMP,0 
		call SEND
		movf TLF9TMP,0 
		call SEND
		movlw '"'
		call SEND
		movlw ENTER
		call SEND
		return

;---------------nastaveni telefonu - echo, identifikace, pamet SIM------------
NASTAV_TLF
; vypnuti echa
		call POSLI_AT
		movlw 'E'
		call SEND
		movlw '0'
		call SEND
		movlw ENTER
		call SEND
		call NAJDI_OK

; nastaveni SIM pro tlf
		call POSLI_ATPLUSC
		movlw 'P'
		call SEND
		movlw 'M'
		call SEND
		movlw 'S'
		call SEND
		movlw '='
		call SEND
		movlw '"'
		call SEND
		movlw 'S'
		call SEND
		movlw 'M'
		call SEND
		movlw '"'
		call SEND
		movlw ENTER
		call SEND
		call NAJDI_OK

; nastaveni SIM pro SMS
		call POSLI_ATPLUSC
		movlw 'P'
		call SEND
		movlw 'B'
		call SEND
		movlw 'S'
		call SEND
		movlw '='
		call SEND
		movlw '"'
		call SEND
		movlw 'S'
		call SEND
		movlw 'M'
		call SEND
		movlw '"'
		call SEND
		movlw ENTER
		call SEND
		call NAJDI_OK

; nastaveni identifikace volajiciho
		call POSLI_ATPLUSC
		movlw 'L'
		call SEND
		movlw 'I'
		call SEND
		movlw 'P'
		call SEND
		movlw '='
		call SEND
		movlw '1'
		call SEND
		movlw ENTER
		call SEND
		call NAJDI_OK


		return

;---------------vycteni tlf cisel z mobilu a ulozeni do pameti----------------
NACTI_TLF_CISLA
; vyslani prikazu pro nacteni cisel z pameti tlf - 1
		call POSLI_ATPLUSC
		movlw 'P'
		call SEND
		movlw 'B'
		call SEND
		movlw 'R'
		call SEND
		movlw '='
		call SEND
		movlw '1'
		call SEND
		movlw ENTER
		call SEND

		call NACTI_A_TEST_TLF_CISLA
		btfss FLAGS2,CISLO_OK
		goto TEL_CHYBA1 

		call RECEIVE	; precteni +420
		call RECEIVE
		call RECEIVE
		call RECEIVE
; precteni a ulozeni cisla
		call RECEIVE
		movwf TLFA1
		call RECEIVE
		movwf TLFA2
		call RECEIVE
		movwf TLFA3
		call RECEIVE
		movwf TLFA4
		call RECEIVE
		movwf TLFA5
		call RECEIVE
		movwf TLFA6
		call RECEIVE
		movwf TLFA7
		call RECEIVE
		movwf TLFA8
		call RECEIVE
		movwf TLFA9
		call NAJDI_OK

; vyslani prikazu pro nacteni cisel z pameti tlf - 2
		call POSLI_ATPLUSC
		movlw 'P'
		call SEND
		movlw 'B'
		call SEND
		movlw 'R'
		call SEND
		movlw '='
		call SEND
		movlw '2'
		call SEND
		movlw ENTER
		call SEND

		call NACTI_A_TEST_TLF_CISLA
		btfss FLAGS2,CISLO_OK
		goto TEL_CHYBA2

		call RECEIVE	; precteni +420
		call RECEIVE
		call RECEIVE
		call RECEIVE
; precteni a ulozeni cisla
		call RECEIVE
		movwf TLFB1
		call RECEIVE
		movwf TLFB2
		call RECEIVE
		movwf TLFB3
		call RECEIVE
		movwf TLFB4
		call RECEIVE
		movwf TLFB5
		call RECEIVE
		movwf TLFB6
		call RECEIVE
		movwf TLFB7
		call RECEIVE
		movwf TLFB8
		call RECEIVE
		movwf TLFB9
		call NAJDI_OK

; vyslani prikazu pro nacteni cisel z pameti tlf - 3
		call POSLI_ATPLUSC
		movlw 'P'
		call SEND
		movlw 'B'
		call SEND
		movlw 'R'
		call SEND
		movlw '='
		call SEND
		movlw '3'
		call SEND
		movlw ENTER
		call SEND

		call NACTI_A_TEST_TLF_CISLA
		btfss FLAGS2,CISLO_OK
		goto TEL_CHYBA3

		call RECEIVE	; precteni +420
		call RECEIVE
		call RECEIVE
		call RECEIVE
; precteni a ulozeni cisla
		call RECEIVE
		movwf TLFC1
		call RECEIVE
		movwf TLFC2
		call RECEIVE
		movwf TLFC3
		call RECEIVE
		movwf TLFC4
		call RECEIVE
		movwf TLFC5
		call RECEIVE
		movwf TLFC6
		call RECEIVE
		movwf TLFC7
		call RECEIVE
		movwf TLFC8
		call RECEIVE
		movwf TLFC9
		call NAJDI_OK

		goto TELCIS_KONEC

TEL_CHYBA1
		bcf PORTA,LED			;zhasni LED
		call CEKAME_1
		call CEKAME_1
		bsf PORTA,LED			;rozsvit LED
		call CEKAME_1
		call CEKAME_1
		call CEKAME_1
		call CEKAME_1
		call CEKAME_1
		bcf PORTA,LED			;zhasni LED

		clrf KONTRPOSSMS1

TEL_CHYBA2
		clrf KONTRPOSSMS2

TEL_CHYBA3
		clrf KONTRPOSSMS3


TELCIS_KONEC
		bcf PORTA,LED		;zhasni LED

		return

;---------------vycteni cislice a ulozeni do TMPKONTR----------------
NACTI_CISLICI_KONF
		clrf TMPKONTR
		call RECEIVE
		movwf TMP			;uloz znak do tempu
		bcf STATUS,Z
		movlw '0'			;testuj znak 0 - t.zn. cidlo neaktivni
		subwf TMP,W
		btfsc STATUS,Z		; Z=1 => shoda
		bsf TMPKONTR,0
		movlw '1'			;testuj znak 1 - t.zn. cidlo aktivni, klidovy stav 1
		subwf TMP,W
		btfsc STATUS,Z		; Z=1 => shoda
		bsf TMPKONTR,1
		movlw '2'			;testuj znak 2
		subwf TMP,W
		btfsc STATUS,Z		; Z=1 => shoda
		bsf TMPKONTR,2
		movlw '3'			;testuj znak 3
		subwf TMP,W
		btfsc STATUS,Z		; Z=1 => shoda
		bsf TMPKONTR,3
		return

;---------------nacteni konfigurace cidla----------------
NACTI_KONF_CIDLA
		call NACTI_CISLICI_KONF

		btfsc TMPKONTR,0
		goto CIDLOAH0
		btfsc TMPKONTR,1
		goto CIDLOAH1
		btfsc TMPKONTR,2
		goto CIDLOAH2
		goto CIDLOB

CIDLOAH0
		bcf KONTRVZOR,4
		bcf KONTRPRODL,4
		goto CIDLOB
CIDLOAH1
		bsf KONTRVZOR,4
		bsf STAVOK,4
		goto CIDLOB
CIDLOAH2
		bsf KONTRVZOR,4
		bcf STAVOK,4
		goto CIDLOB

CIDLOB
		call NACTI_CISLICI_KONF

		btfsc TMPKONTR,0
		goto CIDLOBH0
		btfsc TMPKONTR,1
		goto CIDLOBH1
		goto CIDLOC

CIDLOBH0
		bcf KONTRPRODL,4
		btfsc KONTRVZOR,4
		bsf KONTRPRODL,4
		goto CIDLOC
CIDLOBH1
		bcf KONTRPRODL,4
		goto CIDLOC

CIDLOC
		call NACTI_CISLICI_KONF

		btfsc TMPKONTR,0
		goto CIDLOCH0
		btfsc TMPKONTR,1
		goto CIDLOCH1
		goto CIDLOD

CIDLOCH0
		bcf KONTRPRIPRODL,4
		goto CIDLOD
CIDLOCH1
		bsf KONTRPRIPRODL,4
		goto CIDLOD

CIDLOD
		call NACTI_CISLICI_KONF

		btfsc TMPKONTR,0
		goto CIDLODH0
		btfsc TMPKONTR,1
		goto CIDLODH1
		btfsc TMPKONTR,2
		goto CIDLODH2
		btfsc TMPKONTR,3
		goto CIDLODH3
		goto CIDLOKONEC

CIDLODH0
		bcf KONTRPOSSMS1,1
		bcf KONTRPOSSMS2,1
		bcf KONTRPOSSMS3,1
		goto CIDLOKONEC
CIDLODH1
		bsf KONTRPOSSMS1,1
		bcf KONTRPOSSMS2,1
		bcf KONTRPOSSMS3,1
		goto CIDLOKONEC
CIDLODH2
		bsf KONTRPOSSMS1,1
		bsf KONTRPOSSMS2,1
		bcf KONTRPOSSMS3,1
		goto CIDLOKONEC
CIDLODH3
		bsf KONTRPOSSMS1,1
		bsf KONTRPOSSMS2,1
		bsf KONTRPOSSMS3,1
		goto CIDLOKONEC

CIDLOKONEC
		return


;---------------vycteni tlf cisel konfigurace z mobilu a ulozeni do pameti----------------
NACTI_A_TEST_TLF_CISLA
; nalezeni uvozovek
; precteni  znaku
		bcf FLAGS2,CISLO_OK
		bcf FLAGS1,NO_RECEIVE
		call RECEIVE
		btfsc FLAGS1,NO_RECEIVE		; testovani chyboveho bitu NO_RECEIVE
		goto RETTELTEST

		movwf TMP			;uloz znak do tempu
		bcf STATUS,Z
	
		movlw 'E'			;testuj znak E - t.zn. vraci ERROR
		subwf TMP,W
		btfsc STATUS,Z		; Z=1 => shoda
		goto RETTELTEST
		movlw 'O'			;testuj znak O - t.zn. vraci pouze OK, misto v tel seznamu neobsazeno
		subwf TMP,W
		btfsc STATUS,Z		; Z=1 => shoda
		goto RETTELTEST
		movlw '"'			;testuj znak , - t.zn. vraci telefonni cislo
		subwf TMP,W
		btfsc STATUS,Z		; Z=1 => shoda
		goto CISLOTELTEST
		goto $-18
CISLOTELTEST
		bsf FLAGS2,CISLO_OK
RETTELTEST
		return

;---------------vycteni tlf cisel konfigurace z mobilu a ulozeni do pameti----------------
NACTI_TLF_CISLA_KONF
; vyslani prikazu pro nacteni cisel z pameti tlf - 1
		call POSLI_ATPLUSC
		movlw 'P'
		call SEND
		movlw 'B'
		call SEND
		movlw 'R'
		call SEND
		movlw '='
		call SEND
		movlw '6'
		call SEND
		movlw ENTER
		call SEND

		call NACTI_A_TEST_TLF_CISLA
		btfss FLAGS2,CISLO_OK
		goto RETTEL
;CISLOTEL
		call RECEIVE
		movwf TMP				;uloz znak do tempu
		bcf STATUS,Z
		movlw '*'			;testuj znak * - t.zn. zacatek cisla konfigurace
		subwf TMP,W
		btfss STATUS,Z		; Z=1 => shoda
		goto RETTEL

; precteni a nastaveni konfigurace CIDLO1
		call NACTI_KONF_CIDLA

; precteni a nastaveni konfigurace CIDLO2
		rrf KONTRVZOR,1
		rrf KONTRPRODL,1
		rrf STAVOK,1
		rrf KONTRPRIPRODL,1

		rrf KONTRPOSSMS1,1
; preneseni bitu C do bitu 7
		btfss STATUS,C
		bcf	KONTRPOSSMS1,7
		btfsc STATUS,C
		bsf	KONTRPOSSMS1,7

		rrf KONTRPOSSMS2,1
; preneseni bitu C do bitu 7
		btfss STATUS,C
		bcf	KONTRPOSSMS2,7
		btfsc STATUS,C
		bsf	KONTRPOSSMS2,7

		rrf KONTRPOSSMS3,1
; preneseni bitu C do bitu 7
		btfss STATUS,C
		bcf	KONTRPOSSMS3,7
		btfsc STATUS,C
		bsf	KONTRPOSSMS3,7

		call NACTI_KONF_CIDLA


; precteni a nastaveni konfigurace CIDLO3
		rrf KONTRVZOR,1
		rrf KONTRPRODL,1
		rrf STAVOK,1
		rrf KONTRPRIPRODL,1
		rrf KONTRPOSSMS1,1
; preneseni bitu C do bitu 7
		btfss STATUS,C
		bcf	KONTRPOSSMS1,7
		btfsc STATUS,C
		bsf	KONTRPOSSMS1,7

		rrf KONTRPOSSMS2,1
; preneseni bitu C do bitu 7
		btfss STATUS,C
		bcf	KONTRPOSSMS2,7
		btfsc STATUS,C
		bsf	KONTRPOSSMS2,7

		rrf KONTRPOSSMS3,1
; preneseni bitu C do bitu 7
		btfss STATUS,C
		bcf	KONTRPOSSMS3,7
		btfsc STATUS,C
		bsf	KONTRPOSSMS3,7

		call NACTI_KONF_CIDLA


; precteni a nastaveni konfigurace CIDLO4
		rlf KONTRVZOR,1
		rlf KONTRPRODL,1
		rlf STAVOK,1
		rlf KONTRPRIPRODL,1

		rlf KONTRVZOR,1
		rlf KONTRPRODL,1
		rlf STAVOK,1
		rlf KONTRPRIPRODL,1

		rlf KONTRVZOR,1
		rlf KONTRPRODL,1
		rlf STAVOK,1
		rlf KONTRPRIPRODL,1

		rrf KONTRPOSSMS1,1
; preneseni bitu C do bitu 7
		btfss STATUS,C
		bcf	KONTRPOSSMS1,7
		btfsc STATUS,C
		bsf	KONTRPOSSMS1,7

		rrf KONTRPOSSMS2,1
; preneseni bitu C do bitu 7
		btfss STATUS,C
		bcf	KONTRPOSSMS2,7
		btfsc STATUS,C
		bsf	KONTRPOSSMS2,7

		rrf KONTRPOSSMS3,1
; preneseni bitu C do bitu 7
		btfss STATUS,C
		bcf	KONTRPOSSMS3,7
		btfsc STATUS,C
		bsf	KONTRPOSSMS3,7

		call NACTI_KONF_CIDLA

; posun registru zpet na puvodni misto
		rrf KONTRVZOR,1
		rrf KONTRPRODL,1
		rrf STAVOK,1
		rrf KONTRPRIPRODL,1

		rlf KONTRPOSSMS1,1
; preneseni bitu C do bitu 0
		btfss STATUS,C
		bcf	KONTRPOSSMS1,0
		btfsc STATUS,C
		bsf	KONTRPOSSMS1,0

		rlf KONTRPOSSMS1,1
; preneseni bitu C do bitu 0
		btfss STATUS,C
		bcf	KONTRPOSSMS1,0
		btfsc STATUS,C
		bsf	KONTRPOSSMS1,0

		rlf KONTRPOSSMS1,1
; preneseni bitu C do bitu 0
		btfss STATUS,C
		bcf	KONTRPOSSMS1,0
		btfsc STATUS,C
		bsf	KONTRPOSSMS1,0

		rlf KONTRPOSSMS2,1
; preneseni bitu C do bitu 0
		btfss STATUS,C
		bcf	KONTRPOSSMS2,0
		btfsc STATUS,C
		bsf	KONTRPOSSMS2,0

		rlf KONTRPOSSMS2,1
; preneseni bitu C do bitu 0
		btfss STATUS,C
		bcf	KONTRPOSSMS2,0
		btfsc STATUS,C
		bsf	KONTRPOSSMS2,0

		rlf KONTRPOSSMS2,1
; preneseni bitu C do bitu 0
		btfss STATUS,C
		bcf	KONTRPOSSMS2,0
		btfsc STATUS,C
		bsf	KONTRPOSSMS2,0

		rlf KONTRPOSSMS3,1
; preneseni bitu C do bitu 0
		btfss STATUS,C
		bcf	KONTRPOSSMS3,0
		btfsc STATUS,C
		bsf	KONTRPOSSMS3,0

		rlf KONTRPOSSMS3,1
; preneseni bitu C do bitu 0
		btfss STATUS,C
		bcf	KONTRPOSSMS3,0
		btfsc STATUS,C
		bsf	KONTRPOSSMS3,0

		rlf KONTRPOSSMS3,1
; preneseni bitu C do bitu 0
		btfss STATUS,C
		bcf	KONTRPOSSMS3,0
		btfsc STATUS,C
		bsf	KONTRPOSSMS3,0

		call NAJDI_OK

		bcf PORTA,LED			;zhasni LED
		call CEKAME_1
		bsf PORTA,LED			;rozsvit LED
		call CEKAME_1
		bcf PORTA,LED			;zhasni LED

RETTEL
		bcf PORTA,LED		;zhasni LED
		return

;---------------vycteni tlf cisel konfigurace na pozici7 z mobilu a ulozeni do pameti----------------
NACTI_TLF_CISLA_KONF7
; vyslani prikazu pro nacteni cisel z pameti tlf - 1
		call POSLI_ATPLUSC
		movlw 'P'
		call SEND
		movlw 'B'
		call SEND
		movlw 'R'
		call SEND
		movlw '='
		call SEND
		movlw '7'
		call SEND
		movlw ENTER
		call SEND

		call NACTI_A_TEST_TLF_CISLA
		btfss FLAGS2,CISLO_OK
		goto RETTEL7
;CISLOTEL
		call RECEIVE
		movwf TMP				;uloz znak do tempu
		bcf STATUS,Z
		movlw '*'			;testuj znak * - t.zn. zacatek cisla konfigurace
		subwf TMP,W
		btfss STATUS,Z		; Z=1 => shoda
		goto RETTEL7

; nacteni poctu tel cisel, na ktera se bude volat
		call NACTI_CISLICI_KONF

		btfsc TMPKONTR,0
		goto TELHOVOR1
		btfsc TMPKONTR,1
		goto TELHOVOR1
		btfsc TMPKONTR,2
		goto TELHOVOR2
		btfsc TMPKONTR,3
		goto TELHOVOR3
		btfsc TMPKONTR,4
		goto TELHOVOR4
		btfsc TMPKONTR,5
		goto TELHOVOR5
		goto TELHOVORVZDY

TELHOVOR1
	    movlw .1
        movwf POCETHOVORM
		bcf NASTAVENI,VOLEJXXX
		goto TELHOVORVZDY
TELHOVOR2
	    movlw .2
        movwf POCETHOVORM
		bsf NASTAVENI,VOLEJXXX
		goto TELHOVORVZDY
TELHOVOR3
	    movlw .3
        movwf POCETHOVORM
		bsf NASTAVENI,VOLEJXXX
		goto TELHOVORVZDY
TELHOVOR4
	    movlw .4
        movwf POCETHOVORM
		bsf NASTAVENI,VOLEJXXX
		goto TELHOVORVZDY
TELHOVOR5
	    movlw .5
        movwf POCETHOVORM
		bsf NASTAVENI,VOLEJXXX
		goto TELHOVORVZDY


TELHOVORVZDY
; nacteni zda se bude na vice cisel volat vzdy
		call NACTI_CISLICI_KONF
		
		btfsc TMPKONTR,0
		bcf NASTAVENI,VOLEJVZDY
		btfsc TMPKONTR,1
		bsf NASTAVENI,VOLEJVZDY
		
; nacteni zda se bude posilat SMS o stavu napajeni
		call NACTI_CISLICI_KONF
		
		btfsc TMPKONTR,0
		goto SMSNAP0
		btfsc TMPKONTR,1
		goto SMSNAP1
		btfsc TMPKONTR,2
		goto SMSNAP2
		btfsc TMPKONTR,3
		goto SMSNAP3
		goto SMSNAPKONEC

SMSNAP0
		bcf KONTRPOSSMS1,5
		bcf KONTRPOSSMS1,6
		bcf KONTRPOSSMS2,5
		bcf KONTRPOSSMS2,6
		bcf KONTRPOSSMS3,5
		bcf KONTRPOSSMS3,6
		goto SMSNAPKONEC
SMSNAP1
		bsf KONTRPOSSMS1,5
		bsf KONTRPOSSMS1,6
		bcf KONTRPOSSMS2,5
		bcf KONTRPOSSMS2,6
		bcf KONTRPOSSMS3,5
		bcf KONTRPOSSMS3,6
		goto SMSNAPKONEC
SMSNAP2
		bsf KONTRPOSSMS1,5
		bsf KONTRPOSSMS1,6
		bsf KONTRPOSSMS2,5
		bsf KONTRPOSSMS2,6
		bcf KONTRPOSSMS3,5
		bcf KONTRPOSSMS3,6
		goto SMSNAPKONEC
SMSNAP3
		bsf KONTRPOSSMS1,5
		bsf KONTRPOSSMS1,6
		bsf KONTRPOSSMS2,5
		bsf KONTRPOSSMS2,6
		bsf KONTRPOSSMS3,5
		bsf KONTRPOSSMS3,6
		goto SMSNAPKONEC

SMSNAPKONEC


		call NAJDI_OK

		bcf PORTA,LED			;zhasni LED
		call CEKAME_1
		bsf PORTA,LED			;rozsvit LED
		call CEKAME_1
		bcf PORTA,LED			;zhasni LED

RETTEL7
		bcf PORTA,LED		;zhasni LED
		return



;---------------kontrola cidel-------------------------------------
KONTROLACIDEL
; kontrola cidel
		movf PORTB,0	; stav portu B do W
		xorwf STAVOK,0	; porovnani se stavem OK, pri rozdilu je v prisl. bitech 1 
		andwf KONTR,0	; logicky soucin W a KONTR - kontrolovat prislusnou zonu?
		movwf TMP0	; vysledek kontroly do TMP0

; vyhodnoceni stavu Cidlo1
		btfsc TMP0,CIDLO1	; test naruseni Cidlo1
		bcf KONTR,CIDLO1	; Cidlo1 se nadale nebude kontrolovat
; vyhodnoceni stavu Cidlo2
		btfsc TMP0,CIDLO2	; test naruseni Cidlo2
		bcf KONTR,CIDLO2	; Cidlo2 se nadale nebude kontrolovat
; vyhodnoceni stavu Cidlo3
		btfsc TMP0,CIDLO3	; test naruseni Cidlo3
		bcf KONTR,CIDLO3	; Cidlo3 se nadale nebude kontrolovat
; vyhodnoceni stavu Cidlo4
		btfsc TMP0,CIDLO4	; test naruseni Cidlo4
		bcf KONTR,CIDLO4	; Cidlo4 se nadale nebude kontrolovat

		return
;---------------test cidel-------------------------------------
TESTCIDEL
; kontrola cidel a nasledne spusteni poplachu
		movf PORTB,0	; stav portu B do W
		xorwf STAVOK,0	; porovnani se stavem OK, pri rozdilu je v prisl. bitech 1 
		andwf KONTR,0	; logicky soucin W a KONTR - kontrolovat prislusnou zonu?
		movwf TMP0	; vysledek kontroly do TMP0

		btfss FLAGS2,ODCHODPRODL2
		goto PRODLEVANE
		incf TMP0,1
		decfsz TMP0,1
		goto PRODLEVAJO
		bcf FLAGS2,ODCHODPRODL2		
		goto PRODLEVANE

PRODLEVAJO
		movf TMP0,0
		andwf KONTRPRODL,0
		movwf TMP0

PRODLEVANE

; vyhodnoceni stavu Cidlonap - pouze informace SMS pri zmene, nevola
		btfss FLAGS1,STAVVYPINACE
		goto KONTZNAP
		btfss PORTA,CIDLONAP	; test naruseni Cidlonap, vyvod RA4
		goto UNAPTRUE	; napeti ano
		btfsc FLAGS1,STAVNAPETI	   ;0=napeti ano, 1=napeti ne
		goto KONTZNAP
		bsf FLAGS1,STAVNAPETI
		bsf STAVSMS1,5		; naplneni bitu5 - vypadek napajeni  
		bsf STAVSMS2,5		; naplneni bitu5 - vypadek napajeni  
		bsf STAVSMS3,5		; naplneni bitu5 - vypadek napajeni  
		bsf STAVHOVOR,SMSPOSLI	; SMS se posle hned, bez prodlevy, pri poklesu nap se nevola

		goto KONTZNAP 	
UNAPTRUE
		btfss FLAGS1,STAVNAPETI	   ;0=napeti ano, 1=napeti ne
		goto KONTZNAP
		bcf FLAGS1,STAVNAPETI
		bsf STAVSMS1,6		; naplneni bitu6 - napajeni obnoveno 
		bsf STAVSMS2,6		; naplneni bitu6 - napajeni obnoveno 
		bsf STAVSMS3,6		; naplneni bitu6 - napajeni obnoveno 
		bsf STAVHOVOR,SMSPOSLI	; SMS se posle hned, bez prodlevy, pri poklesu nap se nevola

KONTZNAP

; vyhodnoceni stavu Cidlo1
		btfss TMP0,CIDLO1	; test naruseni Cidlo1
		goto KONTZ1	; zona v poradku
		bcf KONTR,CIDLO1	; Cidlo1 se nadale nebude kontrolovat
		bsf STAVSMS1,1		; naplneni bitu1 
		bsf STAVSMS2,1		; naplneni bitu1 
		bsf STAVSMS3,1		; naplneni bitu1 

		btfsc KONTRPRIPRODL,CIDLO1 ; test, zda ma cidlo prichozi prodlevu 	
		goto $+3   
	    movlw b'00000001'  ; vynulovani prodlevy pred prvnim volanim (pouze u cidla bez prodlevy)
        movwf CVOLAT1

		btfss STAVHOVOR,NARUSENI ; test, zda jde o dalsi narusene cidlo (pak se nenastavuje VOLAT1) 	
		bsf STAVHOVOR,VOLAT1

		btfss STAVHOVOR,NARUSENI ; test, zda jde o dalsi narusene cidlo (pak se nenastavuje SMSPRODL) 	
		bsf STAVHOVOR,SMSPRODL

		bsf STAVHOVOR,NARUSENI	; naplneni STAVHOVOR bit0 (NARUSENI) - 1

KONTZ1

; vyhodnoceni stavu Cidlo2
		btfss TMP0,CIDLO2	; test naruseni Cidlo2
		goto KONTZ2	; zona v poradku
		bcf KONTR,CIDLO2	; Cidlo2 se nadale nebude kontrolovat
		bsf STAVSMS1,2		; naplneni bitu2 
		bsf STAVSMS2,2		; naplneni bitu2 
		bsf STAVSMS3,2		; naplneni bitu2 

		btfsc KONTRPRIPRODL,CIDLO2 ; test, zda ma cidlo prichozi prodlevu 	
		goto $+3   
        movlw b'00000001'  ; vynulovani prodlevy pred prvnim volanim (pouze u cidla bez prodlevy)
        movwf CVOLAT1
		btfss STAVHOVOR,NARUSENI ; test, zda jde o dalsi narusene cidlo (pak se nenastavuje VOLAT1) 	
		bsf STAVHOVOR,VOLAT1

		btfss STAVHOVOR,NARUSENI ; test, zda jde o dalsi narusene cidlo (pak se nenastavuje SMSPRODL) 	
		bsf STAVHOVOR,SMSPRODL

		bsf STAVHOVOR,NARUSENI	; naplneni STAVHOVOR bit0 (NARUSENI) - 1

KONTZ2

; vyhodnoceni stavu Cidlo3
		btfss TMP0,CIDLO3	; test naruseni Cidlo3
		goto KONTZ3	; zona v poradku
		bcf KONTR,CIDLO3	; Cidlo3 se nadale nebude kontrolovat
		bsf STAVSMS1,3		; naplneni bitu3 
		bsf STAVSMS2,3		; naplneni bitu3 
		bsf STAVSMS3,3		; naplneni bitu3 

		btfsc KONTRPRIPRODL,CIDLO3 ; test, zda ma cidlo prichozi prodlevu 	
		goto $+3   
        movlw b'00000001'  ; vynulovani prodlevy pred prvnim volanim (pouze u cidla bez prodlevy)
        movwf CVOLAT1
		btfss STAVHOVOR,NARUSENI ; test, zda jde o dalsi narusene cidlo (pak se nenastavuje VOLAT1) 	
		bsf STAVHOVOR,VOLAT1

		btfss STAVHOVOR,NARUSENI ; test, zda jde o dalsi narusene cidlo (pak se nenastavuje SMSPRODL) 	
		bsf STAVHOVOR,SMSPRODL

		bsf STAVHOVOR,NARUSENI	; naplneni STAVHOVOR bit0 (NARUSENI) - 1

KONTZ3

; vyhodnoceni stavu Cidlo4
		btfss TMP0,CIDLO4	; test naruseni Cidlo4
		goto KONTZ4	; zona v poradku
		bcf KONTR,CIDLO4	; Cidlo4 se nadale nebude kontrolovat
		bsf STAVSMS1,4		; naplneni bitu4 
		bsf STAVSMS2,4		; naplneni bitu4 
		bsf STAVSMS3,4		; naplneni bitu4 

		btfsc KONTRPRIPRODL,CIDLO4 ; test, zda ma cidlo prichozi prodlevu 	
		goto $+3   
        movlw b'00000001'  ; vynulovani prodlevy pred prvnim volanim (pouze u cidla bez prodlevy)
        movwf CVOLAT1
		btfss STAVHOVOR,NARUSENI ; test, zda jde o dalsi narusene cidlo (pak se nenastavuje VOLAT1) 	
		bsf STAVHOVOR,VOLAT1

		btfss STAVHOVOR,NARUSENI ; test, zda jde o dalsi narusene cidlo (pak se nenastavuje SMSPRODL) 	
		bsf STAVHOVOR,SMSPRODL

		bsf STAVHOVOR,NARUSENI	; naplneni STAVHOVOR bit0 (NARUSENI) - 1

KONTZ4

		return



;---------------prijima znaky z MT (RING, BUSY, NO CARRIER)------------
PRIJMI_ZNAKY	; v pripade prichoziho znaku, nejedna se o odpoved na AT prikaz
DALSI_ZNAK
		bcf FLAGS1,NO_RECEIVE
		call RECEIVE

		btfss FLAGS1,STAVVYPINACE		; testovani stavu vypinace, je=li alarm neaktivni, nereaguje na znaky
		goto NECTIZNAKY
		movwf TMP				;uloz znak do tempu
		bcf STATUS,Z
		movlw 'G'			;testuj znak G - t.zn. prichozi hovor
		subwf TMP,W
		btfsc STATUS,Z		; Z=1 => shoda
		goto RING
		movlw 'B'			;testuj znak B - t.zn. je obsazeno
		subwf TMP,W
		btfsc STATUS,Z		; Z=1 => shoda
		goto BUSY
		movlw 'C'			;testuj znak N - t.zn. protejsek zavesil
		subwf TMP,W
		btfsc STATUS,Z		; Z=1 => shoda
		goto NO_CARRIER
NECTIZNAKY
		btfsc FLAGS1,NO_RECEIVE		; testovani chyboveho bitu NO_RECEIVE
		goto RETP
		goto DALSI_ZNAK

RING	
		bsf PORTA,LED			;rozsvit LED;
		call CEKAME_1
		bcf PORTA,LED			;zhasnit LED
		call CEKAME_1
		call CEKAME_1

		goto RETP
BUSY	
;		call CEKAME_1
		call ZAVESIT
		bcf STAVHOVOR,HOVORTYP
        movlw b'00000001'  ; vynulovani doby volani, pri obsazeni je nutno volat znovu - stejne jako kdyz to nezvednu		
		movwf CVOLANI
		
		goto RETP
NO_CARRIER
		call ZAVESIT
		bcf STAVHOVOR,HOVORTYP
		bcf STAVHOVOR,VOLANI

		goto RETP

RETP	

		return

;---------------vyslani AT--------------------------------------
POSLI_AT
		movlw	'A'
		call SEND
		movlw 'T'
		call SEND
		return
;---------------vyslani AT+C--------------------------------------
POSLI_ATPLUSC
		movlw	'A'
		call SEND
		movlw 'T'
		call SEND
		movlw	'+'
		call SEND
		movlw 'C'
		call SEND
		return
;---------------vyslani AT+CMSS=--------------------------------------
POSLI_ATPLUSCMSS
		movlw	'A'
		call SEND
		movlw 'T'
		call SEND
		movlw	'+'
		call SEND
		movlw 'C'
		call SEND
		movlw 'M'
		call SEND
		movlw 'S'
		call SEND
		movlw 'S'
		call SEND
		movlw '='
		call SEND
		return

;---------------kontrola vykonani prikazu--------------------------------------
KONTROLUJ_CHYBU
		movlw 0x3C  ;60 DEC, tj 12 vterin (60x200ms v RECEIVE)
        movwf CAS2
		bcf FLAGS2,NO_OK

		bcf FLAGS1,NO_RECEIVE
		call RECEIVE
		btfss FLAGS1,NO_RECEIVE		; testovani chyboveho bitu NO_RECEIVE
		goto ZNAKJE
        decfsz CAS2,F
        goto $-5

		bsf FLAGS2,NO_OK
		goto KONECEE		

	
ZNAKJE	movwf TMP				;uloz znak do tempu
		bcf STATUS,Z
		movlw 'E'			;testuj znak E - t.zn. vraci ERROR
		subwf TMP,W
		btfsc STATUS,Z		; Z=1 => shoda
		bsf FLAGS2,NO_OK
		bcf FLAGS1,NO_RECEIVE
		call RECEIVE
		btfsc FLAGS1,NO_RECEIVE		; testovani chyboveho bitu NO_RECEIVE
		goto KONECEE
		goto $-10
		
KONECEE	return	



;---------------poslani SMS--------------------------------------
POSLI_SMS_KOMPLET

; poslani SMS na prvni tel. cislo
		movf TLFA1,0	; stav TLFA1 do W
		movwf TLF1TMP	; stav W do TLF1TMP, tj TLFA1 do TLF1TMP
		movf TLFA2,0	; stav TLFA2 do W
		movwf TLF2TMP	; stav W do TLF2TMP, tj TLFA2 do TLF2TMP
		movf TLFA3,0	; stav TLFA3 do W
		movwf TLF3TMP	; stav W do TLF31TMP, tj TLFA3 do TLF3TMP
		movf TLFA4,0	; stav TLFA4 do W
		movwf TLF4TMP	; stav W do TLF4TMP, tj TLFA4 do TLF4TMP
		movf TLFA5,0	; stav TLFA5 do W
		movwf TLF5TMP	; stav W do TLF5TMP, tj TLFA5 do TLF5TMP
		movf TLFA6,0	; stav TLFA6 do W
		movwf TLF6TMP	; stav W do TLF6TMP, tj TLFA6 do TLF6TMP
		movf TLFA7,0	; stav TLFA7 do W
		movwf TLF7TMP	; stav W do TLF7TMP, tj TLFA7 do TLF7TMP
		movf TLFA8,0	; stav TLFA8 do W
		movwf TLF8TMP	; stav W do TLF8TMP, tj TLFA8 do TLF8TMP
		movf TLFA9,0	; stav TLFA9 do W
		movwf TLF9TMP	; stav W do TLF9TMP, tj TLFA9 do TLF9TMP

		movf STAVSMS1,0	; stav STAVSMS1 do W
		movwf STAVSMS	; stav W do STAVSMS, tj STAVSMS1 do STAVSMS

		movf KONTRPOSSMS1,0	; stav KONTRPOSSMS1 do W
		andwf STAVSMS,1	; logicky soucin W (KONTRPOSSMS) a STAVSMS - poslat prislusnou SMS?
		call POSLI_SMS
		movf STAVSMS,0	; stav STAVSMS do W
		movwf STAVSMS1	; stav W do STAVSMS1, tj STAVSMS do STAVSMS1

; poslani SMS na druhe tel. cislo
		movf TLFB1,0	; stav TLFB1 do W
		movwf TLF1TMP	; stav W do TLF1TMP, tj TLFB1 do TLF1TMP
		movf TLFB2,0	; stav TLFB2 do W
		movwf TLF2TMP	; stav W do TLF2TMP, tj TLFB2 do TLF2TMP
		movf TLFB3,0	; stav TLFB3 do W
		movwf TLF3TMP	; stav W do TLF31TMP, tj TLFB3 do TLF3TMP
		movf TLFB4,0	; stav TLFB4 do W
		movwf TLF4TMP	; stav W do TLF4TMP, tj TLFB4 do TLF4TMP
		movf TLFB5,0	; stav TLFB5 do W
		movwf TLF5TMP	; stav W do TLF5TMP, tj TLFB5 do TLF5TMP
		movf TLFB6,0	; stav TLFB6 do W
		movwf TLF6TMP	; stav W do TLF6TMP, tj TLFB6 do TLF6TMP
		movf TLFB7,0	; stav TLFB7 do W
		movwf TLF7TMP	; stav W do TLF7TMP, tj TLFB7 do TLF7TMP
		movf TLFB8,0	; stav TLFB8 do W
		movwf TLF8TMP	; stav W do TLF8TMP, tj TLFB8 do TLF8TMP
		movf TLFB9,0	; stav TLFB9 do W
		movwf TLF9TMP	; stav W do TLF9TMP, tj TLFB9 do TLF9TMP

		movf STAVSMS2,0	; stav STAVSMS2 do W
		movwf STAVSMS	; stav W do STAVSMS, tj STAVSMS2 do STAVSMS

		movf KONTRPOSSMS2,0	; stav KONTRPOSSMS1 do W
		andwf STAVSMS,1	; logicky soucin W (KONTRPOSSMS) a STAVSMS - poslat prislusnou SMS?
		call POSLI_SMS
		movf STAVSMS,0	; stav STAVSMS do W
		movwf STAVSMS2	; stav W do STAVSMS2, tj STAVSMS do STAVSMS2


; poslani SMS na treti tel. cislo
		movf TLFC1,0	; stav TLFC1 do W
		movwf TLF1TMP	; stav W do TLF1TMP, tj TLFC1 do TLF1TMP
		movf TLFC2,0	; stav TLFC2 do W
		movwf TLF2TMP	; stav W do TLF2TMP, tj TLFC2 do TLF2TMP
		movf TLFC3,0	; stav TLFC3 do W
		movwf TLF3TMP	; stav W do TLF31TMP, tj TLFC3 do TLF3TMP
		movf TLFC4,0	; stav TLFC4 do W
		movwf TLF4TMP	; stav W do TLF4TMP, tj TLFC4 do TLF4TMP
		movf TLFC5,0	; stav TLFC5 do W
		movwf TLF5TMP	; stav W do TLF5TMP, tj TLFC5 do TLF5TMP
		movf TLFC6,0	; stav TLFC6 do W
		movwf TLF6TMP	; stav W do TLF6TMP, tj TLFC6 do TLF6TMP
		movf TLFC7,0	; stav TLFC7 do W
		movwf TLF7TMP	; stav W do TLF7TMP, tj TLFC7 do TLF7TMP
		movf TLFC8,0	; stav TLFC8 do W
		movwf TLF8TMP	; stav W do TLF8TMP, tj TLFC8 do TLF8TMP
		movf TLFC9,0	; stav TLFC9 do W
		movwf TLF9TMP	; stav W do TLF9TMP, tj TLFC9 do TLF9TMP

		movf STAVSMS3,0	; stav STAVSMS2 do W
		movwf STAVSMS	; stav W do STAVSMS, tj STAVSMS3 do STAVSMS

		movf KONTRPOSSMS3,0	; stav KONTRPOSSMS1 do W
		andwf STAVSMS,1	; logicky soucin W (KONTRPOSSMS) a STAVSMS - poslat prislusnou SMS?
		call POSLI_SMS
		movf STAVSMS,0	; stav STAVSMS do W
		movwf STAVSMS3	; stav W do STAVSMS3, tj STAVSMS do STAVSMS3
		return




;---------------poslani SMS--------------------------------------
POSLI_SMS


		btfss STAVSMS,1	; testovani, zda se ma poslat prislusna SMS
		goto SMS1SS
		call POSLI_ATPLUSCMSS
		movlw '1'
		call SEND
		movlw ','
		call SEND
		call POSLI_CISLO

		bcf STAVSMS,1
		call KONTROLUJ_CHYBU
		btfsc FLAGS2,NO_OK
		bsf STAVSMS,1


SMS1SS
		btfss STAVSMS,2	; testovani, zda se ma poslat prislusna SMS
		goto SMS2SS
		call POSLI_ATPLUSCMSS
		movlw '2'
		call SEND
		movlw ','
		call SEND
		call POSLI_CISLO

		bcf STAVSMS,2
		call KONTROLUJ_CHYBU
		btfsc FLAGS2,NO_OK
		bsf STAVSMS,2


SMS2SS
		btfss STAVSMS,3	; testovani, zda se ma poslat prislusna SMS
		goto SMS3SS
		call POSLI_ATPLUSCMSS
		movlw '3'
		call SEND
		movlw ','
		call SEND
		call POSLI_CISLO

		bcf STAVSMS,3
		call KONTROLUJ_CHYBU
		btfsc FLAGS2,NO_OK
		bsf STAVSMS,3


SMS3SS
		btfss STAVSMS,4	; testovani, zda se ma poslat prislusna SMS
		goto SMS4SS
		call POSLI_ATPLUSCMSS
		movlw '4'
		call SEND
		movlw ','
		call SEND
		call POSLI_CISLO

		bcf STAVSMS,4
		call KONTROLUJ_CHYBU
		btfsc FLAGS2,NO_OK
		bsf STAVSMS,4

SMS4SS
		btfss STAVSMS,5	; testovani, zda se ma poslat prislusna SMS
		goto SMS5SS
		call POSLI_ATPLUSCMSS
		movlw '5'
		call SEND
		movlw ','
		call SEND
		call POSLI_CISLO

		bcf STAVSMS,5
		call KONTROLUJ_CHYBU
		btfsc FLAGS2,NO_OK
		bsf STAVSMS,5


SMS5SS
		btfss STAVSMS,6	; testovani, zda se ma poslat prislusna SMS
		goto SMS6SS
		call POSLI_ATPLUSCMSS
		movlw '6'
		call SEND
		movlw ','
		call SEND
		call POSLI_CISLO

		bcf STAVSMS,6
		call KONTROLUJ_CHYBU
		btfsc FLAGS2,NO_OK
		bsf STAVSMS,6

SMS6SS
		return

;---------------Hleda znak K a ENTER 0D (hexa) v odpovedi MT------------
NAJDI_OK	
ZAC0	bcf FLAGS1,TMPOK
ZAC1	call RECEIVE
		btfsc FLAGS1,NO_RECEIVE		; testovani chyboveho bitu NO_RECEIVE
		goto RETTT
		movwf TMP				;uloz znak do tempu
		bcf STATUS,Z
		movlw 'K'			;testuj znak K
		subwf TMP,W
		btfss STATUS,Z		; Z=1 => shoda
		goto ZAC2	 
		bsf FLAGS1,TMPOK
		goto ZAC1
ZAC2	btfss FLAGS1,TMPOK		; TMPOK=1 => predchozi znak byl K
		goto ZAC1
		bcf STATUS,Z
		movlw ENTER			;testuj znak ENTER (0x0D)
		subwf TMP,W
		btfss STATUS,Z		; Z=1 => shoda
		goto ZAC0
		call RECEIVE	; precteni znaku 0A


RETTT	bcf FLAGS1,NO_RECEIVE

		return
;---------------zjisteni stavu hovoru po volani tlf. cisla----------------
ZJISTI_STAV

		call POSLI_ATPLUSC
		movlw 'L'
		call SEND
		movlw 'C'
		call SEND
		movlw 'C'
		call SEND
		movlw ENTER
		call SEND
; precteni  znaku
		bcf FLAGS1,NO_RECEIVE
		call RECEIVE
		btfsc FLAGS1,NO_RECEIVE		; testovani chyboveho bitu NO_RECEIVE
		goto RET1
		movwf TMP			;uloz znak do tempu
		bcf STATUS,Z
	
		movlw 'E'			;testuj znak E - t.zn. vraci ERROR
		subwf TMP,W
		btfsc STATUS,Z		; Z=1 => shoda
		goto CHYBAE
	
		movlw ','			;testuj znak , - t.zn. vraci stav
		subwf TMP,W
		btfsc STATUS,Z		; Z=1 => shoda
		goto CARKA
		movlw 'O'			;testuj znak O - t.zn. vraci pouze OK
		subwf TMP,W
		btfsc STATUS,Z		; Z=1 => shoda
		goto OKAA
		goto $-17

OKAA	call NAJDI_OK
		call ZAVESIT
		bcf STAVHOVOR,VOLANI
		bcf STAVHOVOR,HOVORTYP

		goto RET1
CARKA
		call RECEIVE
		call RECEIVE
		call RECEIVE
		movwf TMP			;uloz znak do tempu
		bcf STATUS,Z
		movlw '2'			;testuj znak 2 - t.zn. vytaci
		subwf TMP,W
		btfsc STATUS,Z		; Z=1 => shoda
		goto VYTACI
		movlw '3'			;testuj znak 3 - t.zn. vyzvani
		subwf TMP,W
		btfsc STATUS,Z		; Z=1 => shoda
		goto VYZVANI
		movlw '0'			;testuj znak 0 - t.zn. hovor spojen
		subwf TMP,W
		btfsc STATUS,Z		; Z=1 => shoda
		goto PROBIHA
		goto RET1
VYTACI  call NAJDI_OK

		goto RET1
VYZVANI call NAJDI_OK

		goto RET1
PROBIHA call NAJDI_OK
		btfsc NASTAVENI,VOLEJXXX ;pri vice tel musi zavesit
		call ZAVESIT
		btfsc NASTAVENI,VOLEJXXX
		bsf STAVHOVOR,HOVOR
		bcf STAVHOVOR,VOLANI

		goto RET1

CHYBAE	call NAJDI_OK

RET1	bcf FLAGS1,NO_RECEIVE
		return

;-----------------------------------------------------------------

;************************ Inicializace procesoru  *************************
INIT
		clrf	FLAGS1
		clrf	FLAGS2
		movlw 7
		movwf CMCON		; CMCON=7 set comparators off         

		bcf STATUS,RP0	; switch to bank 0



        bsf STATUS,RP0          ; RAM PAGE 1
		bcf OPTION_REG, 7		; enable internal pullups
        movlw b'11110010'		;port RA3, RA2, RA0 is OUT
        movwf TRISA		; portA
		movlw b'11111011'	;  input is all, RB2 is out 
		movwf TRISB	; port B

	
;	------------------------
; nastaveni USART asynchr, Boot Baud Rate = 19200, No Parity, 1 Stop Bit
	
	    movlw 0x0C              ; 0x0C=19200 bps
        movwf SPBRG
        movlw b'00100100'       ; brgh = high (2)
        movwf TXSTA             ; enable Async Transmission, set brgh
 	
;----------------- Hlavni program ---------------------------

		call TEST_PRIPOJENI

		call NASTAV_TLF

;-----------------------------------
; nastaveni TIMER2 na 1ms

	    movlw b'00000101'		; preddelicka 1:4, timer2 ON
        movwf T2CON
        bsf STATUS,RP0          ; RAM PAGE 1
	    movlw 0xFA				; PR2=250
        movwf PR2
        bcf STATUS,RP0          ; RAM PAGE 0

; nastaveni pocatecni hodnoty promenne

		movlw 0x64			; 100ms
		movwf TIME100MS
		movlw 0x0A			; 1s
		movwf TIME1S
		movlw 0x3C			; 1min
		movwf TIME1M
		movlw KTIMECIDEL		; konstanta doba kontroly cidel
		movwf TIMECIDEL
		movlw KTIMESMS			; konstanta doba SMS
		movwf TIMESMS
		movlw KKONTRPRODL ; nastaveni cidel, ktera nemaji pri odchodu prodlevu(prislusny bit je 1)
		movwf KONTRPRODL
		movlw KKONTRVZOR ; nastaveni cidel, ktera se maji kontrolovat
		movwf KONTRVZOR
		movlw b'00000000' ; nic se nekontroluje, nabiha do stavu vypnuto, i kdyz je vypinac ve stavu Alarm aktivovan
		movwf KONTR
		movlw KSTAVOK ; nastaveni reg STAVOK na stav OK
		movwf STAVOK
		movlw KKONTRPOSSMS1; nastaveni, zda se ma poslat SMS
		movwf KONTRPOSSMS1
		movlw KKONTRPOSSMS2; nastaveni, zda se ma poslat SMS
		movwf KONTRPOSSMS2
		movlw KKONTRPOSSMS3; nastaveni, zda se ma poslat SMS
		movwf KONTRPOSSMS3
		movlw KKONTRPRIPRODL ; nastaveni cidel, ktera maji pri prichodu prodlevu(prislusny bit je 1)
		movwf KONTRPRIPRODL
		clrf STAVHOVOR		; nulovani registru pro stav hovoru
		clrf STAVSMS		; nulovani registru pro stav SMS
		clrf STAVSMS1		; nulovani registru pro stav SMS
		clrf STAVSMS2		; nulovani registru pro stav SMS
		clrf STAVSMS3		; nulovani registru pro stav SMS
		movlw KNARUSENI			; konstanta doba nez se po naruseni vrati do pohotovostniho stavu
		movwf CNARUSENI
		movlw KVOLAT1			; konstanta prodleva pred prvnim volanim po naruseni
		movwf CVOLAT1
		movlw KVOLANI			; konstanta doba volani
		movwf CVOLANI
		movlw KHOVORTYP			; konstanta doby zjistovani stavu
		movwf CHOVORTYP
		movlw KSMSPRODL			; konstanta prodleva pred prvnim poslanim SMS po naruseni
		movwf CSMSPRODL
		movlw KODCHODPRODL		; konstanta prodlevy pri odchodu
		movwf CODCHODPRODL
		movlw KBLIKANINO		; konstanta doby zhasnuti LED v pohotovostnim stavu
		movwf CBLIKANI

		movlw KNASTAVENI ; nastaveni zda se ma volat na vic tel cisel
		movwf NASTAVENI

		movlw KPOCETHOVOR 	; implicitni nastaveni poctu hovoru
		movwf POCETHOVORM	; pocet hovoru
		movf POCETHOVORM,0
		movwf POCETHOVOR	; promenna pro pocitani hovoru


;-------------------------------------------------------------------------------------------

		call NACTI_TLF_CISLA_KONF

		call NACTI_TLF_CISLA_KONF7

		call NACTI_TLF_CISLA

 




;-----------------------------------
;cyklus 1ms		
TEST1MS
		btfss PIR1,TMR2IF	; testovani uplynuti 1ms - TMR2IF=1
		goto $-1
		bcf PIR1,TMR2IF
		btfsc PIR1,RCIF		; testovani, zda neprisel znak (napr. prichozi volani)
		call PRIJMI_ZNAKY

		decfsz TIME100MS,1	; testovani uplynuti 100ms ----------------100ms-----------------------
		goto TEST1MS
		movlw 0x64			; 100ms
		movwf TIME100MS

		decfsz TIMECIDEL,1		; testovani uplynuti doby pro testovani cidel
		goto $+4
		movlw KTIMECIDEL			; konstanta doba kontroly cidel
		movwf TIMECIDEL
		call TESTCIDEL

;cyklus CHOVORTYP+++++++++++++++++++++++++++++
		btfss STAVHOVOR,HOVORTYP	; testovani doby zjistovani stavu volani
		goto HOVORTYPSS
		decfsz CHOVORTYP,1		
		goto HOVORTYPSS
		call ZJISTI_STAV
		movlw KHOVORTYP			; konstanta doby zjistovani stavu volani
		movwf CHOVORTYP

HOVORTYPSS

;cyklus CBLIKANI+++++++++++++++++++++++++++++
		btfss FLAGS1,STAVVYPINACE	; testovani stavu vypinace
		goto BLIKANISS
		decfsz CBLIKANI,1		
		goto BLIKANISS
		btfss FLAGS1,LEDSVIT
		goto LEDSVITYES
		bcf PORTA,LED			;zhasni LED
		bcf FLAGS1,LEDSVIT
		movlw KBLIKANINO			; konstanta doby zhasnuti LED v pohotovostnim stavu
		movwf CBLIKANI
		goto BLIKANISS
LEDSVITYES
		bsf PORTA,LED			;rozsvit LED
		bsf FLAGS1,LEDSVIT
		movlw KBLIKANIYES			; konstanta doby svitu LED v pohotovostnim stavu
		movwf CBLIKANI
BLIKANISS
;+++++++++++++++++++++++++++++++++++++++++++

		decfsz TIME1S,1		; testovani uplynuti 1s--------------------1s----------------------------
		goto TEST1MS
		movlw 0x0A			; 1s
		movwf TIME1S

;kontrola stavu vypinace - 0=alarm vypnut, 1=alarm zapnut+++++++++++++++++++++++++++
		btfss PORTA,VYPINAC	; testovani stavu vypinace
		goto VYPNUTO
		btfsc FLAGS1, STAVVYPINACE
		goto ODPRODL
		bsf FLAGS1,ODCHODPRODL
		bsf FLAGS1,STAVVYPINACE
		bsf FLAGS1,LEDSVIT
		bsf PORTA,LED			;rozsvit LED
		movlw KBLIKANIYES			; konstanta doby svitu LED v pohotovostnim stavu
		movwf CBLIKANI
		movf KONTRPRODL,0 
		movwf KONTR
ODPRODL	btfss FLAGS1,ODCHODPRODL	; testovani uplynuti doby prodlevy po odchodu
		goto VYPSS
		decfsz CODCHODPRODL,1		
		goto VYPSS
		bcf FLAGS1,ODCHODPRODL
		bsf FLAGS2,ODCHODPRODL2
		movf KONTRVZOR,0 ;  kontroluji se vsechny cidla
		movwf KONTR
		goto VYPSS 
VYPNUTO	btfss FLAGS1, STAVVYPINACE
		goto AASET
		call CEKAME_1		; prodleva, aby vzdy doslo k zavolani, i kdyz bude alarm ihned vypnut
		call CEKAME_1		; prodleva, aby vzdy doslo k zavolani, i kdyz bude alarm ihned vypnut
		call CEKAME_1		; prodleva, aby vzdy doslo k zavolani, i kdyz bude alarm ihned vypnut
		call ZAVESIT
AASET
		bcf FLAGS1,STAVVYPINACE
		bcf FLAGS2,ODCHODPRODL2
		movlw b'00000000' ; nic se nekontroluje 
		movwf KONTR
		clrf STAVHOVOR		; nulovani registru pro stav hovoru
		clrf STAVSMS		; nulovani registru pro stav SMS
		clrf STAVSMS1		; nulovani registru pro stav SMS
		clrf STAVSMS2		; nulovani registru pro stav SMS
		clrf STAVSMS3		; nulovani registru pro stav SMS
		movlw KNARUSENI			; konstanta doba nez se po naruseni vrati do pohotovostniho stavu
		movwf CNARUSENI
		movlw KVOLAT1			; konstanta prodleva pred prvnim volanim po naruseni
		movwf CVOLAT1
		movlw KVOLANI			; konstanta doba volani
		movwf CVOLANI
		movlw KHOVORTYP			; konstanta doby zjistovani stavu
		movwf CHOVORTYP
		movlw KSMSPRODL			; konstanta prodleva pred prvnim poslanim SMS po naruseni
		movwf CSMSPRODL
		movlw KODCHODPRODL			; konstanta prodlevy pri odchodu
		movwf CODCHODPRODL
		movf POCETHOVORM,0
		movwf POCETHOVOR	; promenna pro pocitani hovoru

		bcf PORTA,LED			;zhasni LED
		goto VYPSS

		
VYPSS

;cyklus CVOLAT1+++++++++++++++++++++++++++++
		btfss STAVHOVOR,VOLAT1	; testovani uplynuti doby prodlevy pred prvnim volanim po naruseni
		goto VOLAT1SS
		decfsz CVOLAT1,1		
		goto VOLAT1SS
		call VOLEJ_CISLO 
		bcf STAVHOVOR,VOLAT1
		bsf STAVHOVOR,VOLANI
		bsf STAVHOVOR,HOVORTYP

		movlw KVOLAT2			; konstanta prodleva mezi volanim prvnim a druhym
		movwf CVOLAT1

		btfss NASTAVENI,VOLEJXXX	;pokud se ma volat na vice tel
		goto VOLAT1SS
		bsf STAVHOVOR,VOLAT2
		movlw KVOLAT2XXX		; konstanta prodleva mezi volanim prvnim a druhym pro volani na vice tel.
		movwf CVOLAT1
		
VOLAT1SS
;+++++++++++++++++++++++++++++++++++++++++++

;cyklus CSMSPRODL+++++++++++++++++++++++++++++
		btfss STAVHOVOR,SMSPRODL	; testovani uplynuti doby prodlevy pred prvnim poslanim SMS
		goto SMSPRODLSS
		decfsz CSMSPRODL,1		
		goto SMSPRODLSS
		bcf STAVHOVOR,SMSPRODL
		bsf STAVHOVOR,SMSPOSLI

SMSPRODLSS
;+++++++++++++++++++++++++++++++++++++++++++

;poslani SMS+++++++++++++++++++++++++++++
		btfss STAVHOVOR,SMSPOSLI	; testovani uplynuti doby prodlevy pred prvnim poslanim SMS
		goto SMSPOSLISS
		btfsc STAVHOVOR,VOLANI		
		goto SMSPOSLISS
		call POSLI_SMS_KOMPLET 

SMSPOSLISS
;+++++++++++++++++++++++++++++++++++++++++++

;cyklus CVOLANI+++++++++++++++++++++++++++++
		btfss STAVHOVOR,VOLANI	; testovani doby volani
		goto VOLANIZ7MO
		decfsz CVOLANI,1		
		goto VOLANISS
		call ZAVESIT
		bcf STAVHOVOR,VOLANI
		bcf STAVHOVOR,HOVORTYP


		btfss NASTAVENI,VOLEJXXX
		goto POUZE1
		goto VOLANIZ7

VOLANIZ7MO
		btfss NASTAVENI,VOLEJXXX
		goto VOLANISS
		btfss NASTAVENI,VOLEJVZDY
		goto VOLANISS

VOLANIZ7
		btfss STAVHOVOR,VOLAT2
		goto VOLANISS
		movlw KVOLANI			; konstanta doba volani
		movwf CVOLANI
		movlw KHOVORTYP			; konstanta doby zjistovani stavu
		movwf CHOVORTYP
		decfsz POCETHOVOR,1
		bsf STAVHOVOR,VOLAT1
		bcf STAVHOVOR,VOLAT2
		goto VOLANISS


POUZE1
		movlw KVOLANI			; konstanta doba volani
		movwf CVOLANI
		movlw KHOVORTYP			; konstanta doby zjistovani stavu
		movwf CHOVORTYP
		btfss STAVHOVOR,VOLAT2
		goto DRUHYH
		bcf STAVHOVOR,VOLAT2
		goto DRUHYHK 	
DRUHYH	bsf STAVHOVOR,VOLAT1
		bsf STAVHOVOR,VOLAT2
				
DRUHYHK

VOLANISS
;+++++++++++++++++++++++++++++++++++++++++++
		decfsz TIMESMS,1		; testovani uplynuti doby pro testovani nove SMS
		goto $+4
		movlw KTIMESMS			; konstanta doba SMS
		movwf TIMESMS

		decfsz TIME1M,1		; testovani uplynuti 1min--------------------1min--------------------------
		goto TEST1MS
		movlw 0x3C			; 1min
		movwf TIME1M

;cyklus CNARUSENI++++++++++++++++++++++++++++
		btfss STAVHOVOR,NARUSENI	; testovani uplynuti doby navratu do pohotovostniho stavu
		goto NARUSENISS
		decfsz CNARUSENI,1		
		goto NARUSENISS
;navrat do pohotovostniho stavu - nastaveni pocatecnich hodnot
		btfsc STAVHOVOR,HOVOR	; testovani ,zda probiha hovor - zavesit
		call ZAVESIT
		movf KONTRVZOR,0 ;  kontroluji se vsechny cidla
		movwf KONTR
		call KONTROLACIDEL
		clrf STAVHOVOR		; nulovani registru pro stav hovoru
		clrf STAVSMS		; nulovani registru pro stav SMS
		clrf STAVSMS1		; nulovani registru pro stav SMS
		clrf STAVSMS2		; nulovani registru pro stav SMS
		clrf STAVSMS3		; nulovani registru pro stav SMS
		movlw KNARUSENI			; konstanta doba nez se po naruseni vrati do pohotovostniho stavu
		movwf CNARUSENI
		movlw KVOLAT1			; konstanta prodleva pred prvnim volanim po naruseni
		movwf CVOLAT1
		movlw KVOLANI			; konstanta doba volani
		movwf CVOLANI
		movlw KHOVORTYP			; konstanta doby zjistovani stavu
		movwf CHOVORTYP
		movlw KSMSPRODL			; konstanta prodleva pred prvnim poslanim SMS po naruseni
		movwf CSMSPRODL
		movf POCETHOVORM,0
		movwf POCETHOVOR	; promenna pro pocitani hovoru
NARUSENISS

		goto TEST1MS


	end
